#!/usr/bin/env python3
import logging
from mqtt_flask_instance import mqtt
from db import db
from schemas import DeviceSchema

"""
MQTT Stuff
"""

__author__ = "@tormakris"
__copyright__ = "Copyright 2020, Birbnetes Team"
__module_name__ = "mqtt_methods"
__version__text__ = "1"

deviceschema = DeviceSchema(many=False)


LOGGER = logging.getLogger(__name__)


@mqtt.on_message()
def handle_status_message(client, userdata, message):
    data = dict(
        topic=message.topic,
        payload=message.payload.decode()
    )
    try:
        status_message = deviceschema.load(data['payload'], session=db.session, transient=True).data
        LOGGER.info(f"Recieved status message from {data['payload']['id']}, persisting to db.")
        db.session.merge(status_message)
    except Exception as e:
        db.session.rollback()
        LOGGER.exception(e)
    else:
        db.session.commit()
